<?php
error_reporting(E_ERROR);
// Define functions below this line.
// Define functions above this line.
include "includes/PowerDebug.php";
// include "includes/JSON.php";
// Name of your app:
$app_name = 'powerdebug';

// Basepath of your app:
$base_path = '/apps/' . $app_name;

// BEGIN Session management #

$redir_login = '/app/berogui/includes/login.php';

@session_start();
if (! isset($_SESSION['beroari_time'])) {
    header('Location:' . $redir_login . '?userapp=' . $app_name);
    exit();
} elseif ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time'] + 1200) < time())) {
    @session_unset();
    @session_destroy();
    header('Location:' . $redir_login . '?reason=sess_expd&userapp=' . $app_name);
    exit();
}

unset($redir_login);

$_SESSION['beroari_time'] = time();
// END session management #

if (strcasecmp($_POST['back'], "back") == 0) {
    // echo $_SERVER['HTTP_HOST'];
    header("Location: http://" . $_SERVER['HTTP_HOST'] . "/app/berogui/");
    exit();
}

$tecs_exist = array(
    "isdn" => "false",
    "analog" => "false",
    "gsm" => "false"
);

$analog_debug_device = "";

if (file_exists("/sys/class/bnxanalog/debugtool")) {
    $tecs_exist['analog'] = "true";
    $analog_debug_device = "/sys/class/bnxanalog/debugtool";
}

if (file_exists("/proc/analog_debug")) {
    $tecs_exist['analog'] = "true";
    $analog_debug_device = "/proc/analog_debug";
}

$gsm_debug_device = "";

if (file_exists("/sys/class/bnxgsm/debug")) {
    $tecs_exist['gsm'] = "true";
    $gsm_debug_device = "/sys/class/bnxgsm/debug";
}

exec("/sbin/lsmod | grep mISDN_core", $out);
if (! empty($out))
    $tecs_exist['isdn'] = "true";

$tecs = '{"sip":"' . $_POST['sip'] . '","isdn":"' . $_POST['isdn'] . '","analog":"' . $_POST['analog'] . '","gsm":"' . $_POST['gsm'] . '"}';
$server = $_POST['server'];
$action = strtolower($_POST['action']);
$filter = $_POST['filter'];

if (file_exists("/tmp/powerdebug.lck")) {
    $trace = unserialize(file_get_contents("/tmp/powerdebug.lck"));
    $filter = $trace->filter;
    if (! $trace->isProcessRunning()) {
        $message = "Trace has been cleared, because it was not running anymore.";
        $trace->stop(false);
        // unlink ("/tmp/powerdebug.lck");
    } else {
        $server = $trace->getServer();
        $status = $trace->getStatus();
        if ($status->answer != "SUCCESS") {
            $trace->stop(false);
            $message = "Trace has been cleared, because server doesn't know this trace.";
        } else {
            $trace->getPDObj()->status = $status->message;
            if ($status->message == "STOPPED")
                $trace->stop(false);
        }
    }
} else if (! empty($server)) {
    $trace = new PowerDebug($server, $tecs, $filter);
    if ($tecs_exist['analog'] == "true")
        $trace->analog_debug_device = $analog_debug_device;
    if ($tecs_exist['gsm'] == "true")
        $trace->gsm_debug_device = $gsm_debug_device;
}

if (! empty($trace)) {
    switch ($action) {
        case "start":
            $ret = $trace->init();
            if ($ret->answer == "ERROR")
                $message = print_r($ret, true);
            else
                $ret = $trace->start();
            print_r($ret, true);
            if ($ret->answer == "ERROR")
                $message = print_r($ret, true);
            $message = print_r($ret, true);
            break;
        case "stop":
            $ret = $trace->stop();
            if ($ret->answer == "ERROR")
                $message = print_r($ret, true);
            // $message=$message."\nAnwtort: ".$ret['message'];
            break;
    }
    if (empty($message))
        $message = $trace->getPDObj()->status;
}

if (! ip2long($server) && empty($trace) && ! empty($action)) {
    $message = "'$server' is not a valid IP address.";
}

if (file_exists("/tmp/powerdebug.lck")) {
    $started = true;
    $btn_style = "danger";
    $btn_text = "Stop";
    $img_status = "activity2.gif";
} else {
    $started = false;
    $btn_style = "success";
    $btn_text = "Start";
    $img_status = "circle_red.ico";
}
/*
 * $postvalues=implode(",",$_POST);
 * $message = $postvalues;
 */
if (! empty($trace)) {
    
    if ($trace->tecs->isdn == "true")
        $v_isdn = "checked";
    if ($trace->tecs->analog == "true")
        $v_analog = "checked";
    if ($trace->tecs->sip == "true")
        $v_sip = "checked";
    if ($trace->tecs->gsm == "true")
        $v_gsm = "checked";
    // $message = $message . print_r($trace->tecs,true);
}

?>

<!-- index.html -->

<!doctype html>
<html>
<head>
<title>beroNet PowerDebug App</title>
<link rel="stylesheet" href="css/bootstrap.min.css">
<!-- load bootstrap via CDN -->
<script src="js/jquery.min.js"></script>
<!-- load jquery via CDN -->

</head>
<body>
	<div class="col-sm-6 col-sm-offset-3">

		<h2>PowerDebug - Longterm Debugging for beroNet gateways</h2>
		<div class="panel-group">
			<div class="panel panel-<?echo $btn_style?>">
				<div class="panel-heading">
					Status:<img src="images/<?echo $img_status ?>" width="24"
						height="24">
				</div>
				<div class="panel-body">Message: <?echo $message ?></div>
			</div>
		</div>


		<!-- OUR FORM -->
		<form action="index.php" method="POST">

			<!-- SERVER -->
			<div id="server-group" class="form-group">
				<label for="server">Server</label> <input type="text"
					class="form-control" value="<?echo $server ?>" name="server"
					placeholder="enter your ip of powerdebug server"
					<? if($started) echo "disabled"; ?>>
				<!-- errors will go here -->
			</div>
			<div id="technologies-group" class="form-group">
				<label for="technologies">Protocols to trace: </label>
				<?
    if ($tecs_exist['isdn'] == "true")
        echo '<label class="checkbox-inline"><input type="checkbox" name="isdn" value="true" ' . $v_isdn . '>ISDN</label>';
    if ($tecs_exist['analog'] == "true")
        echo '<label class="checkbox-inline"><input type="checkbox" name="analog" value="true" ' . $v_analog . '>Analog</label>';
    if ($tecs_exist['gsm'] == "true")
        echo '<label class="checkbox-inline"><input type="checkbox" name="gsm" value="true" ' . $v_gsm . '>GSM</label>';
    
    echo '<label class="checkbox-inline"><input type="checkbox" name="sip" value="true" ' . $v_sip . '>SIP</label>';
    ?>
			</div>
			<div class="form-group">
				<label for="filter">Traffic filter:</label> <select
					class="form-control" id="filter" name="filter">
					<option <? echo ($filter=="all"?"selected":""); ?> value="all">All</option>
					<option <? echo ($filter=="siponly"?"selected":""); ?>
						value="siponly">SIP only</option>
					<option <? echo ($filter=="siprtp"?"selected":""); ?>
						value="siprtp">SIP+Audio</option>
				</select>
			</div>

			<div class="btn-group">
				<button name="action" type="submit"
					class="btn btn-<?echo $btn_style?>  btn-lg"
					value="<?echo $btn_text?>"> <?echo $btn_text?></button>
				<button name="back" type="submit" class="btn btn-primary btn-lg"
					value="back">Back</button>
			</div>

		</form>

	</div>
</body>
</html>
<?
exit ();

?>
